/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQOBJECT_H__
#define __SQOBJECT_H__

// ^
#ifndef SQOBJECT
#define SQOBJECT Object
#define SQOBJECTNAME _SC("Object")
#endif

// IuWFNgoChp
#ifndef NOUSESQRAT
#include <sqrat.h>
#else
#include "sqfunc.h"
#endif

#include "sqobjectinfo.h"

namespace sqobject {

const SQChar *getString(HSQUIRRELVM v, SQInteger idx);

/**
 * IuWFNgp
 */
class Object {

protected:
	// squirrelIuWFNg̎ȎQ
	ObjectInfo self;
	// ̃IuWFNg҂ĂXbḧꗗ
	ObjectInfo _waitThreadList;
	// delegate
	ObjectInfo delegate;

public:
#ifdef SQOBJHEAP
	SQHEAPDEFINE;
#endif
	bool isInit() {
		return !self.isNull();
	}
	void push(HSQUIRRELVM v) {
		self.push(v);
	}
	
	/**
	 * IuWFNg҂̓o^
	 * @param thread Xbh
	 */
	void addWait(ObjectInfo &thread);
	
	/**
	 * IuWFNg҂̉
	 * @param thread Xbh
	 */
	void removeWait(ObjectInfo &thread);
	
	/**
	 * RXgN^
	 */
	Object();
	
	/**
	 * RXgN^
	 * @param v squirrelVM
	 * @param delegateIdx fQ[gi[Ăԍ
	 */
	Object(HSQUIRRELVM v, int delegateIdx=2);

	/**
	 * fXgN^
	 */
	virtual ~Object();

	/**
	 * ȎQƏp
	 * ftHgRXgN^ŏꍇ͕K̏Ԃ
	 * @param v SQUIRREL vm
	 * @param idx ̃IuWFNgCfbNX
	 */
	void initSelf(HSQUIRRELVM v, int idx=1);

	/**
	 * jp
	 */
	void destructor();

public:
	
	// ------------------------------------------------------------------

	/**
	 * ̃IuWFNg҂ĂPXbh̑҂
	 */
	void notify();
	
	/**
	 * ̃IuWFNg҂ĂSXbh̑҂
	 */
	void notifyAll();
	
	/**
	 * vpeBl擾
	 * @param name vpeB
	 * @return vpeBl
	 */
	SQRESULT _get(HSQUIRRELVM v);

	/**
	 * vpeBɒlݒ
	 * @param name vpeB
	 * @param value vpeBl
	 */
	SQRESULT _set(HSQUIRRELVM v);

	/**
	 * setvpeB̑݊mF
	 * @param name vpeB
	 * @return setvpeB݂ true
	 */
	SQRESULT hasSetProp(HSQUIRRELVM v);
	
	/**
	 * Ϗ̐ݒ
	 */
	SQRESULT setDelegate(HSQUIRRELVM v);

	/**
	 * Ϗ̎擾
	 */
	SQRESULT getDelegate(HSQUIRRELVM v);

public:
	/**
	 * squirrel NXo^
	 */
	static void registerClass();


protected:

	/**
	 * ȃIuWFNgCxgĂяoi)
	 * C++ squirrel ̎w胁\bhCxgƂăR[obNł܂B
	 * @param eventName Cxg
	 */
	SQRESULT callEvent(const SQChar *eventName) {
		return self.callMethod(eventName);
	}

	/**
	 * ȃIuWFNgCxgĂяoi1)
	 * @param eventName Cxg
	 * @param p1 
	 */
	template<typename T1> SQRESULT callEvent(const SQChar *eventName, T1 p1) {
		return self.callMethod(eventName, p1);
	}
	
	/**
	 * ȃIuWFNgCxgĂяoi2)
	 * @param eventName Cxg
	 * @param p1 
	 * @param p2 2
	 */
	template<typename T1, typename T2> SQRESULT callEvent(const SQChar *eventName, T1 p1, T2 p2) {
		return self.callMethod(eventName, p1, p2);
	}
	
	/**
	 * ԒlL莩ȃIuWFNgCxgĂяoi)
	 * @param r Al|C^
	 * @param eventName Cxg
	 */
	template<typename R> SQRESULT callEventResult(R* r, const SQChar *eventName) {
		return self.callMethodResult(r, eventName);
	}

	/**
	 * Ԓl莩ȃIuWFNgCxgĂяoi1)
	 * @param r Al|C^
	 * @param eventName Cxg
	 * @param p1 
	 */
	template<typename R, typename T1> SQRESULT callEventResult(R* r, const SQChar *eventName, T1 p1) {
		return self.callMethodResult(r, eventName, p1);
	}
	
	/**
	 * ԒlL莩ȃIuWFNgCxgĂяoi2)
	 * @param r Al|C^
	 * @param eventName Cxg
	 * @param p1 
	 * @param p2 2
	 */
	template<typename R, typename T1, typename T2> SQRESULT callEventResult(R* r, const SQChar *eventName, T1 p1, T2 p2) {
		return self.callMethodResult(r, eventName, p1, p2);
	}

};

// ---------------------------------------------------
// IuWFNgoChp
// ---------------------------------------------------

// Object push
// @return ł squirrel pɏς݂ŃCX^XĂ push ł true
bool pushObject(HSQUIRRELVM v, Object *obj);


#ifndef NOUSESQRAT
// l̊i[
// i[sƂ̓IuWFNg폜̂ delete ̕Kv͂Ȃ
//  squirrel ŐꂽIuWFNgꍇ͕K
template<typename T>
void pushValue(HSQUIRRELVM v, T *value) {
	if (value) {
		if (pushObject(v, value)) {
			return;
		}
		Sqrat::Var<T*>::push(v, value);
		return;
	}
	sq_pushnull(v);
}

// l̊i[̑p
template<typename T>
void pushOtherValue(HSQUIRRELVM v, T *value) {
	if (value) {
		Sqrat::Var<T*>::push(v, value);
		return;
	}
	sq_pushnull(v);
}

// l̎擾
template<typename T>
SQRESULT getValue(HSQUIRRELVM v, T **value, int idx=-1) {
	*value = Sqrat::Var<T*>(v, idx).value;
	return SQ_OK;
}
#else

// l̊i[
// i[sƂ̓IuWFNg폜̂ delete ̕Kv͂Ȃ
//  squirrel ŐꂽIuWFNgꍇ͕K
template<typename T>
void pushValue(HSQUIRRELVM v, T *value) {
	if (value) {
		if (pushObject(v, value)) {
			SQClassType<T>::pushInstance(v, value);
			return;
		}
	}
	sq_pushnull(v);
}

// l̎擾
template<typename T>
SQRESULT getValue(HSQUIRRELVM v, T **value, int idx=-1) {
	*value = SQClassType<T>::getInstance(v, idx);
	return SQ_OK;
}
#endif

// l̋
template<typename T>
void clearValue(T **value) {
	*value = 0;
}

// l̎擾
template<typename T>
SQRESULT getResultValue(HSQUIRRELVM v, T **value) {
	return getValue(value);
}


// ---------------------------------------------------------
// StackValue
// ---------------------------------------------------------

/**
 * X^bNQƗp
 */
class StackValue {
	
public:
  // RXgN^
  StackValue(HSQUIRRELVM v, int idx) : v(v), idx(idx) {};
  
  // Cӌ^ւ̃LXg
  // 擾łȂꍇ̓NAlɂȂ
  template<typename T>
  operator T() const
  {
	T value;
	if (SQ_FAILED(getValue(v, &value, idx))) {
	  clearValue(&value);
	}
	return value;
  }

  // IuWFNgPUSH
  void push(HSQUIRRELVM v) const {
	  sq_move(v, this->v, idx);
  }

  // ^Ԃ
  SQObjectType type() const {
	return sq_gettype(v, idx);
  }

  // intl
  SQInteger intValue() const {
	return (SQInteger)*this;
  }

  // flaotl
  SQFloat floatValue() const {
	return (SQFloat)*this;
  }

private:
  HSQUIRRELVM v;
  int idx;
};

void pushValue(HSQUIRRELVM v, const StackValue &sv);

// --------------------------------------------------------------------------------------

/**
 * p
 */
class StackInfo {

public:
	/**
	 * RXgN^
	 * @param vm VM
	 */
	StackInfo(HSQUIRRELVM vm) : vm(vm) {
		argc = sq_gettop(vm) - 1;
	}
	
	/**
	 * @return ̐
	 */
	int len() const {
		return argc;
	}

	/**
	 * @return selfQ
	 */
	ObjectInfo getSelf() const {
		return ObjectInfo(vm, 1);
	}

	/**
	 * @param n ԍ 0`
	 * @return ̌^
	 */
	SQObjectType getType(int n) const {
		if (n < argc) {
			return sq_gettype(vm, n+2);
		}
		return OT_NULL;
	}
	
	/**
	 * @param n ԍ 0`
	 * @return ̌^
	 */
	ObjectInfo getArg(int n) const {
		ObjectInfo ret;
		if (n < argc) {
			ret.getStack(vm, n+2);
		}
		return ret;
	}

	/**
	 * 擾
	 * @param n ԍ 0`
	 * @return IuWFNg
	 */
	ObjectInfo operator[](int n) const {
		return getArg(n);
	}

	// ʓo^
	SQRESULT setReturn() const { return 0; }
	template<typename T>
	SQRESULT setReturn(T value) const {
		pushValue(vm, value);
		return 1;
	}

protected:
	HSQUIRRELVM vm; //< VM
	SQInteger argc; //< ̐
};

};// namespace

#endif
