
#include <windows.h>
#include <tchar.h>
#include "ncbind/ncbind.hpp"


#ifndef IDI_TVPWIN32
#define IDI_TVPWIN32 107 // [XXX]
#endif
#define WM_TASKTRAY (WM_APP + 2591)
#define IDI_MY_ICON TJS_W("tasktray icon")

class WindowTasktray {
public:
  static void registerWindowMessage(void) {
    sTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
  }

protected:
    static UINT sTaskbarRestart;

	iTJSDispatch2 *objthis; //< IuWFNg̎Q
	bool tasktrayEnable;     //< ^XNgCLǂ
    HWND hwnd;
    ttstr hint;
    tjs_int infoIcon;
    ttstr infoTitle;
    ttstr infoMsg;
    tjs_int infoTimeout;

	typedef bool (__stdcall *NativeReceiver)(iTJSDispatch2 *obj, void *userdata, tTVPWindowMessage *Message);
  
	static bool __stdcall MyReceiver(void *userdata, tTVPWindowMessage *Message) {
		iTJSDispatch2 *obj = (iTJSDispatch2*)userdata; // Window ̃IuWFNg
		// gg̓̊֌WŃCxg͓o^jłĂ΂邱Ƃ̂
		// Window ̖{̃IuWFNglCeBuIuWFNg蒼
		WindowTasktray *self = ncbInstanceAdaptor<WindowTasktray>::GetNativeInstance(obj);
		if (self == NULL) {
			return false;
		}
		switch (Message->Msg) {
		case TVP_WM_DETACH: // EChE؂藣ꂽ
			break; 
		case TVP_WM_ATTACH: // EChEݒ肳ꂽ
			break;
		case WM_TASKTRAY: // O̒ʐM
			{
              tTJSVariant cursorX, cursorY;
              obj->PropGet(0 , L"cursorX", NULL, &cursorX, obj);
              obj->PropGet(0 , L"cursorY", NULL, &cursorY, obj);
              tjs_int shiftValue = 0;
              if (GetKeyState(VK_SHIFT)) shiftValue |= TVP_SS_SHIFT;
              if (GetKeyState(VK_CONTROL)) shiftValue |= TVP_SS_CTRL;
              if (GetKeyState(VK_MENU)) shiftValue |= TVP_SS_ALT;
              tTJSVariant shift = shiftValue;
              tTJSVariant button;
              switch ( Message->LParam ){
              case WM_MOUSEMOVE: {
                /* }EXړ̏ */
                tTJSVariant *params[] = { &cursorX, &cursorY, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseMove", NULL, NULL, 3, params, obj));
              }
              case WM_LBUTTONUP: {
                /* {^ꂽ */
                button = mbLeft;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseUp", NULL, NULL, 4, params, obj));
              }
              case WM_RBUTTONUP: {
                /* E{^ꂽ */
                button = mbRight;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseUp", NULL, NULL, 4, params, obj));
              }
              case WM_MBUTTONUP: {
                /* {^ꂽ */
                button = mbMiddle;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseUp", NULL, NULL, 4, params, obj));
              }
              case WM_LBUTTONDOWN: {
                /* {^ꂽ */
                button = mbLeft;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseDown", NULL, NULL, 4, params, obj));
              }
              case WM_RBUTTONDOWN: {
                /* E{^ꂽ */
                button = mbRight;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseDown", NULL, NULL, 4, params, obj));
              }
              case WM_MBUTTONDOWN: {
                /* {^ꂽ */
                button = mbMiddle;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayMouseDown", NULL, NULL, 4, params, obj));
              }
              case WM_LBUTTONDBLCLK: {
                /* _uNbNꂽ */
                button = mbLeft;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayDoubleClick", NULL, NULL, 4, params, obj));
              }
              case WM_RBUTTONDBLCLK: {
                /* E_uNbNꂽ */
                button = mbRight;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayDoubleClick", NULL, NULL, 4, params, obj));
              }
              case WM_MBUTTONDBLCLK: {
                /* _uNbNꂽ */
                button = mbMiddle;
                tTJSVariant *params[] = { &cursorX, &cursorY, &button, &shift };
                return ! TJS_SUCCEEDED(Try_iTJSDispatch2_FuncCall(obj, 0, L"onTasktrayDoubleClick", NULL, NULL, 4, params, obj));
              }
              default:
                /* LȊȌ */
                break;
              }
              return true;
            }
		default:
          // ^XNo[č쐬ꂽۂɓo^
          if (Message->Msg == sTaskbarRestart
              && self->tasktrayEnable) {
            self->registerTasktray(true);
           }
          break;
		}
		return false;
	}

	/**
	 * V[o̓o^
	 */
	void registerReceiver(bool enable) {
		// V[oXV
		tTJSVariant mode    = enable ? (tTVInteger)(tjs_int)wrmRegister : (tTVInteger)(tjs_int)wrmUnregister;
		tTJSVariant proc     = (tTVInteger)(tjs_int)MyReceiver;
		tTJSVariant userdata = (tTVInteger)(tjs_int)objthis;
		tTJSVariant *p[3] = {&mode, &proc, &userdata};
		int ret = objthis->FuncCall(0, L"registerMessageReceiver", NULL, NULL, 3, p, objthis);
	}

  /**
   * ^XNgC̓o^
   */
  void registerTasktray(bool enable) {
    if (enable) {
      HINSTANCE hinst = GetModuleHandle(NULL);
      HICON   r = LoadIcon(hinst, L"MAINICON"); // for krkr2
      if (!r) r = LoadIcon(hinst, MAKEINTRESOURCE(IDI_TVPWIN32)); // for krkrz
      if (!r) r = LoadIcon(hinst, IDI_APPLICATION); // for others

      NOTIFYICONDATA nid = { 0 };
      nid.cbSize = sizeof(nid);
      nid.uFlags = NIF_ICON | NIF_MESSAGE |NIF_TIP;
      nid.hWnd = hwnd;
      nid.hIcon = r;
      nid.uCallbackMessage = WM_TASKTRAY;
      wcsncpy_s(nid.szTip, sizeof(nid.szTip) / sizeof(TCHAR), hint.c_str(), hint.length());
      for (;;) {
		if (Shell_NotifyIcon(NIM_ADD, &nid))
          // o^łI
          break;
        // ^CAEgǂׂ
        if (::GetLastError() != ERROR_TIMEOUT)
          // ACRo^G[
          TVPThrowExceptionMessage(L"tasktray register failed.");
        // ҋ@
        ::Sleep(1000);
        // o^łĂȂƂmF
        if (Shell_NotifyIcon(NIM_MODIFY, &nid))
          // o^łĂ
          break;
      }
      DestroyIcon(nid.hIcon);
    } else {
      NOTIFYICONDATA nid = { 0 };
      nid.cbSize = sizeof(nid);
      nid.hWnd = hwnd;
      Shell_NotifyIcon(NIM_DELETE, &nid);
    }      
  }

  void updateTasktray(UINT flags) {
      NOTIFYICONDATA nid = { 0 };
      nid.cbSize = sizeof(nid);
      nid.uFlags = flags;
      nid.hWnd = hwnd;
      if (flags & NIF_TIP)
        wcsncpy_s(nid.szTip, sizeof(nid.szTip) / sizeof(TCHAR), hint.c_str(), hint.length());
      if (flags & NIF_INFO) {
        wcsncpy_s(nid.szInfo, sizeof(nid.szInfo) / sizeof(TCHAR), infoMsg.c_str(), infoMsg.length());
        wcsncpy_s(nid.szInfoTitle, sizeof(nid.szInfoTitle) / sizeof(TCHAR), infoTitle.c_str(), infoTitle.length());
        nid.dwInfoFlags = infoIcon;
        nid.uTimeout = infoTimeout;
      } 
      Shell_NotifyIcon(NIM_MODIFY, &nid);
  }

public:
	// RXgN^
	WindowTasktray(iTJSDispatch2 *objthis) : objthis(objthis), tasktrayEnable(false) {
      tTJSVariant val;
      objthis->PropGet(0, TJS_W("HWND"), NULL, &val, objthis);
      hwnd = reinterpret_cast<HWND>((tjs_int64)(val));
    }

	// fXgN^
	~WindowTasktray() {
		// V[o
      setTasktrayEnable(false);
	}

	/**
	 * ^XNgCLǂݒ
	 * @param enable true ȂL
	 */
	void setTasktrayEnable(bool enable) {
		if (tasktrayEnable != enable) {
			tasktrayEnable = enable;
			registerReceiver(tasktrayEnable);
            registerTasktray(tasktrayEnable);
		} 
	}

	/**
	 * @return ^XNgCLǂ擾
	 */
	bool getTasktrayEnable() {
		return tasktrayEnable;
	}

  /**
   * ^XNgC̃qgݒ肷
   * @param text eLXg
   */
  void setTasktrayHint(ttstr text) {
    hint = text;
    if (tasktrayEnable)
      updateTasktray(NIF_TIP);
  }

  /**
   * ^XNgC̃qg擾ݒ肷
   * @return eLXg
   */
  ttstr getTasktrayHint(void) {
    return hint;
  }

  /**
   * ^XNgC̃o[`bvݒ肷
   * @param icon ACR
   * @param title ^Cg
   * @param msg bZ[W
   * @param timeout ^CAEg(msB10000`30000̊ԂŐݒ肷)
   */
  void popupTasktrayInfo(tjs_int icon, ttstr title, ttstr msg, tjs_int timeout) {
    infoIcon = icon;
    infoTitle = title;
    infoMsg = msg;
    infoTimeout = timeout;
    if (tasktrayEnable) 
      updateTasktray(NIF_INFO);
  }
};

UINT WindowTasktray::sTaskbarRestart;


void
PreRegistCallback()
{
  WindowTasktray::registerWindowMessage();
  TVPExecuteExpression(L"global.niifNone = 0");
  TVPExecuteExpression(L"global.niifInfo = 1");
  TVPExecuteExpression(L"global.niifWarning = 2");
  TVPExecuteExpression(L"global.niifError = 3");
}

void PostUnregistCallback()
{
  TVPExecuteScript(L"delete global[\"niifNone\"];");
  TVPExecuteScript(L"delete global[\"niifInfo\"];");
  TVPExecuteScript(L"delete global[\"niifWarning\"];");
  TVPExecuteScript(L"delete global[\"niifError\"];");
}

// CX^XQb^
NCB_GET_INSTANCE_HOOK(WindowTasktray)
{
	NCB_INSTANCE_GETTER(objthis) { // objthis  iTJSDispatch2* ^̈Ƃ
		ClassT* obj = GetNativeInstance(objthis);	// lCeBuCX^X|C^擾
		if (!obj) {
			obj = new ClassT(objthis);				// Ȃꍇ͐
			SetNativeInstance(objthis, obj);		// objthis  obj lCeBuCX^XƂēo^
		}
		return obj;
	}
};
    
// tbNA^b`
NCB_ATTACH_CLASS_WITH_HOOK(WindowTasktray, Window) {
	Property(L"tasktrayEnable", &WindowTasktray::getTasktrayEnable, &WindowTasktray::setTasktrayEnable);
	Property(L"tasktrayHint", &WindowTasktray::getTasktrayHint, &WindowTasktray::setTasktrayHint);
    Method(L"popupTasktrayInfo", &WindowTasktray::popupTasktrayInfo);
}

NCB_PRE_REGIST_CALLBACK(PreRegistCallback);
NCB_POST_UNREGIST_CALLBACK(PostUnregistCallback);
